- Elementary
- Main
- Authors
- Examples
- Files
- Pages
- Types
- Modules

Enumerations | Functions
Focus

An Elementary application has, at all times, one (and only one) focused object. More...

## Enumerations
enum | Elm_Focus_Direction { ELM_FOCUS_PREVIOUS, ELM_FOCUS_NEXT, ELM_FOCUS_UP, ELM_FOCUS_DOWN, ELM_FOCUS_RIGHT, ELM_FOCUS_LEFT }
| Focus directions. More...

## Functions
Eina_Bool | elm_config_focus_highlight_enabled_get (void)
| Get the enable status of the focus highlight. More...
void | elm_config_focus_highlight_enabled_set (Eina_Bool enable)
| Set the enable status of the focus highlight. More...
Eina_Bool | elm_config_focus_highlight_animate_get (void)
| Get the enable status of the highlight animation. More...
void | elm_config_focus_highlight_animate_set (Eina_Bool animate)
| Set the enable status of the highlight animation. More...
Eina_Bool | elm_object_focus_get (const Evas_Object *obj)
| Get the whether an Elementary object has the focus or not. More...
void | elm_object_focus_set (Evas_Object *obj, Eina_Bool focus)
| Set/unset focus to a given Elementary object. More...
void | elm_object_focus_allow_set (Evas_Object *obj, Eina_Bool enable)
| Set the ability for an Elementary object to be focused. More...
Eina_Bool | elm_object_focus_allow_get (const Evas_Object *obj)
| Get whether an Elementary object is focusable or not. More...
void | elm_object_focus_custom_chain_set (Evas_Object *obj, Eina_List *objs)
| Set custom focus chain. More...
void | elm_object_focus_custom_chain_unset (Evas_Object *obj)
| Unset a custom focus chain on a given Elementary widget. More...
const Eina_List * | elm_object_focus_custom_chain_get (const Evas_Object *obj)
| Get custom focus chain. More...
void | elm_object_focus_custom_chain_append (Evas_Object *obj, Evas_Object *child, Evas_Object *relative_child)
| Append object to custom focus chain. More...
void | elm_object_focus_custom_chain_prepend (Evas_Object *obj, Evas_Object *child, Evas_Object *relative_child)
| Prepend object to custom focus chain. More...
void | elm_object_focus_next (Evas_Object *obj, Elm_Focus_Direction dir)
| Give focus to next object in object tree. More...
Evas_Object * | elm_object_focus_next_object_get (const Evas_Object *obj, Elm_Focus_Direction dir)
| Get next object which was set with specific focus direction. More...
void | elm_object_focus_next_object_set (Evas_Object *obj, Evas_Object *next, Elm_Focus_Direction dir)
| Set next object with specific focus direction. More...
Evas_Object * | elm_object_focused_object_get (const Evas_Object *obj)
| Get focused object in object tree. More...
void | elm_object_tree_focus_allow_set (Evas_Object *obj, Eina_Bool focusable)
| Make the elementary object and its children to be focusable (or unfocusable). More...
Eina_Bool | elm_object_tree_focus_allow_get (const Evas_Object *obj)
| Get whether an Elementary object and its children are focusable or not. More...

## Detailed Description

An Elementary application has, at all times, one (and only one) focused object.

This is what determines where the input events go to within the application's window. Also, focused objects can be decorated differently, in order to signal to the user where the input is, at a given moment.

Elementary applications also have the concept of focus chain: one can cycle through all the windows' focusable objects by input (tab key) or programmatically. The default focus chain for an application is the one define by the order in which the widgets where added in code. One will cycle through top level widgets, and, for each one containing sub-objects, cycle through them all, before returning to the level above. Elementary also allows one to set custom focus chains for their applications.

Besides the focused decoration a widget may exhibit, when it gets focus, Elementary has a global focus highlight object that can be enabled for a window. If one chooses to do so, this extra highlight effect will surround the current focused object, too.

Note
  Some Elementary widgets are unfocusable, after creation, by their very nature: they are not meant to be interacted with input events, but are there just for visual purposes.

This example contemplates some of these functions.

## Enumeration Type Documentation

enum Elm_Focus_Direction

Focus directions.

Enumerator
ELM_FOCUS_PREVIOUS | previous direction
ELM_FOCUS_NEXT | next direction
ELM_FOCUS_UP | up direction
ELM_FOCUS_DOWN | down direction
ELM_FOCUS_RIGHT | right direction
ELM_FOCUS_LEFT | left direction

## Function Documentation

Eina_Bool elm_config_focus_highlight_animate_get | ( | void |  | ) |

Get the enable status of the highlight animation.

Returns
  The focus highlight mode set

Get whether the focus highlight, if enabled, will animate its switch from one object to the next

void elm_config_focus_highlight_animate_set | ( | Eina_Bool | animate | ) |

Set the enable status of the highlight animation.

Parameters

  animate | Enable animation if EINA_TRUE, disable otherwise

Set whether the focus highlight, if enabled, will animate its switch from one object to the next

Note that it will take effect only to Elementary windows created after this is called.

See Also
  elm_win_add()

Eina_Bool elm_config_focus_highlight_enabled_get | ( | void |  | ) |

Get the enable status of the focus highlight.

This gets whether the highlight on focused objects is enabled or not

See Also
  elm_config_focus_highlight_enabled_set()

void elm_config_focus_highlight_enabled_set | ( | Eina_Bool | enable | ) |

Set the enable status of the focus highlight.

Parameters

  enable | Enable highlight if EINA_TRUE, disable otherwise

Set whether to show or not the highlight on focused objects

Note that it will take effect only to Elementary windows created after this is called.

See Also
  elm_win_add()

Eina_Bool elm_object_focus_allow_get | ( | const Evas_Object * | obj | ) |

Get whether an Elementary object is focusable or not.

Parameters

  obj | The Elementary object to operate on

Returns
  `EINA_TRUE` if the object is allowed to be focused, `EINA_FALSE` if not (and on errors)

Note
  Objects which are meant to be interacted with by input events are created able to be focused, by default. All the others are not.

Referenced by elm_genlist_item_fields_update().

void elm_object_focus_allow_set | ( | Evas_Object * | obj,
|  | Eina_Bool | enable
| ) |  |

Set the ability for an Elementary object to be focused.

Parameters

  obj | The Elementary object to operate on
  enable | `EINA_TRUE` if the object can be focused, `EINA_FALSE` if not (and on errors)

This sets whether the object `obj` is able to take focus or not. Unfocusable objects do nothing when programmatically focused, being the nearest focusable parent object the one really getting focus. Also, when they receive mouse input, they will get the event, but not take away the focus from where it was previously.

Examples:
  general_funcs_example.c.

void elm_object_focus_custom_chain_append | ( | Evas_Object * | obj,
|  | Evas_Object * | child,
|  | Evas_Object * | relative_child
| ) |  |

Append object to custom focus chain.

Note
  If relative_child equal to NULL or not in custom chain, the object will be added in end.
  On focus cycle, only will be evaluated children of this container.

Parameters

  obj | The container object
  child | The child to be added in custom chain
  relative_child | The relative object to position the child

const Eina_List* elm_object_focus_custom_chain_get | ( | const Evas_Object * | obj | ) |

Get custom focus chain.

Parameters

  obj | The container object

void elm_object_focus_custom_chain_prepend | ( | Evas_Object * | obj,
|  | Evas_Object * | child,
|  | Evas_Object * | relative_child
| ) |  |

Prepend object to custom focus chain.

Note
  If relative_child equal to NULL or not in custom chain, the object will be added in begin.
  On focus cycle, only will be evaluated children of this container.

Parameters

  obj | The container object
  child | The child to be added in custom chain
  relative_child | The relative object to position the child

void elm_object_focus_custom_chain_set | ( | Evas_Object * | obj,
|  | Eina_List * | objs
| ) |  |

Set custom focus chain.

This function overwrites any previous custom focus chain within the list of objects. The previous list will be deleted and this list will be managed by elementary. After it is set, don't modify it.

Note
  On focus cycle, only will be evaluated children of this container.

Parameters

  obj | The container object
  objs | Chain of objects to pass focus

void elm_object_focus_custom_chain_unset | ( | Evas_Object * | obj | ) |

Unset a custom focus chain on a given Elementary widget.

Parameters

  obj | The container object to remove focus chain from

Any focus chain previously set on `obj` (for its child objects) is removed entirely after this call.

Eina_Bool elm_object_focus_get | ( | const Evas_Object * | obj | ) |

Get the whether an Elementary object has the focus or not.

Parameters

  obj | The Elementary object to get the information from

Returns
  `EINA_TRUE`, if the object is focused, `EINA_FALSE` if not (and on errors).

See Also
  elm_object_focus_set()

void elm_object_focus_next | ( | Evas_Object * | obj,
|  | Elm_Focus_Direction | dir
| ) |  |

Give focus to next object in object tree.

Give focus to next object in focus chain of one object sub-tree. If the last object of chain already have focus, the focus will go to the first object of chain.

Parameters

  obj | The object root of sub-tree
  dir | Direction to move the focus

See Also
  elm_object_focus_next_object_get(), elm_object_focus_next_object_set()

Evas_Object* elm_object_focus_next_object_get | ( | const Evas_Object * | obj,
|  | Elm_Focus_Direction | dir
| ) |  |

Get next object which was set with specific focus direction.

Get next object which was set by elm_object_focus_next_object_set with specific focus direction.

Parameters

  obj | The Elementary object
  dir | Focus direction

Returns
  Focus next object or `NULL`, if there is no focus next object.

See Also
  elm_object_focus_next_object_set(), elm_object_focus_next()

Since
  1.8

void elm_object_focus_next_object_set | ( | Evas_Object * | obj,
|  | Evas_Object * | next,
|  | Elm_Focus_Direction | dir
| ) |  |

Set next object with specific focus direction.

When focus next object is set with specific focus direction, this object will be the first candidate when finding next focusable object. Focus next object can be registered with six directions that are previous, next, up, down, right, and left.

Parameters

  obj | The Elementary object
  next | Focus next object
  dir | Focus direction

See Also
  elm_object_focus_next_object_get(), elm_object_focus_next()

Since
  1.8

void elm_object_focus_set | ( | Evas_Object * | obj,
|  | Eina_Bool | focus
| ) |  |

Set/unset focus to a given Elementary object.

Parameters

  obj | The Elementary object to operate on.
  focus | `EINA_TRUE` Set focus to a given object, `EINA_FALSE` Unset focus to a given object.

Note
  When you set focus to this object, if it can handle focus, will take the focus away from the one who had it previously and will, for now on, be the one receiving input events. Unsetting focus will remove the focus from `obj`, passing it back to the previous element in the focus chain list.

Warning
  Only visible object can get a focus. Call evas_object_show(o) before calling this API, if you want to give a focus to the evas object.

See Also
  elm_object_focus_get(), elm_object_focus_custom_chain_get()

Examples:
  entry_example.c, general_funcs_example.c, and web_example_02.c.

References ELM_FOCUS_NEXT, and elm_win_inlined_image_object_get().

Evas_Object* elm_object_focused_object_get | ( | const Evas_Object * | obj | ) |

Get focused object in object tree.

This function returns current focused object in one object sub-tree.

Parameters

  obj | The object root of sub-tree

Returns
  Current focused or `NULL`, if there is no focused object.

Since
  1.8

Eina_Bool elm_object_tree_focus_allow_get | ( | const Evas_Object * | obj | ) |

Get whether an Elementary object and its children are focusable or not.

Parameters

  obj | The Elementary object to get the information from

Returns
  `EINA_TRUE`, if the tree is focusable, `EINA_FALSE` if not (and on errors).

See Also
  elm_object_tree_focus_allow_set()

void elm_object_tree_focus_allow_set | ( | Evas_Object * | obj,
|  | Eina_Bool | focusable
| ) |  |

Make the elementary object and its children to be focusable (or unfocusable).

Parameters

  obj | The Elementary object to operate on
  focusable | `EINA_TRUE` for focusable, `EINA_FALSE` for unfocusable.

This sets whether the object `obj` and its children objects are able to take focus or not. If the tree is set as unfocusable, newest focused object which is not in this tree will get focus. This API can be helpful for an object to be deleted. When an object will be deleted soon, it and its children may not want to get focus (by focus reverting or by other focus controls). Then, just use this API before deleting.

See Also
  elm_object_tree_focus_allow_get()

Copyright ©2000-2014 Enlightenment.org - Samsung Electronics supports the EFL Documentation Project - Generated Wed Jan 8 2014 20:51:13